var RE = {};
var bodyPadding = 0;
var placeHolder = '插入图片或写文字';
var historyHtml = '';
/*

 检测章/节里的内容：如果有：
 “第一部分”“第一卷”“第一章”“第一回”“第一讲”“第一篇”“第一节”“第一天”
 “第1部分”“第1卷”“第1章”“第1回”“第1讲”“第1篇”“第1节”“第1天”...（穷举）
 等内容，则自动显示为“第1章　”“第1节　”（即，自动补一个全角空格），但如果后面是“的”就不要自动补空格了，例如“第1天的行程”。

 */

/*

 第一部分	第一卷	第一章	第一回	第一讲	第一篇	第一节	第一天
 第1部分	第1卷	第1章	第1回	第1讲	第1篇	第1节	第1天

 第一天的行程
 第1天的行程

 */

//(第((\d+)|(一))(部分|卷|章|回|讲|篇|节|天))
//(第((\d+)|(一))(部分|卷|章|回|讲|篇|节|天))的

//(第((\d+)|(一))(部分|卷|章|回|讲|篇|节|天))[^的]

//[一|二|三|四|五|六|七|八|九]

//***************************获取处理过的章节标题的帮助类***************************
/*
 version: v1.1.1
 author: yzz
 create time: 2016-11-11
 update time: 2016-12-27
 description: 获取处理过的章节标题的帮助类
 log:
 2016-12-27：添加匹配‘日’字
 2016-11-11：首次启动
 */
var common = {
    pattern: /(^第((\d+)|(([一|二|三|四|五|六|七|八|九]十[一|二|三|四|五|六|七|八|九])|([一|二|三|四|五|六|七|八|九]十)|(十[一|二|三|四|五|六|七|八|九])|([一|二|三|四|五|六|七|八|九])))(部分|卷|章|回|讲|篇|节|天|话|日))[^(的|\u3000)]/g,
    pattern2: /(^第((\d+)|(([一|二|三|四|五|六|七|八|九]十[一|二|三|四|五|六|七|八|九])|([一|二|三|四|五|六|七|八|九]十)|(十[一|二|三|四|五|六|七|八|九])|([一|二|三|四|五|六|七|八|九])))(部分|卷|章|回|讲|篇|节|天|话|日))/g,
    isMatch: function (str, pattern) {
        return !!str.match(pattern);
    },
}
var helper = {
    getTitle: function (title) {
        if (!title) {
            return "";
        } else {
            if (common.isMatch(title, common.pattern)) {
                title = title.replace(common.pattern2, "$1　");		//全角空格
            }
            return title.trim();
        }
    }
}

RE.currentSelection = {
    "startContainer": 0,
    "startOffset": 0,
    "endContainer": 0,
    "endOffset": 0
};

RE.init = function () {
    //找到标题，禁止换行和设置可编辑属性
    $('.M-Art-View-Title').each(function () {
        $(this).attr('contentEditable', 'true');
        $(this)[0].onkeydown = function (event) {
            var wasEnterPressed = (event.keyCode == '13');
            if (wasEnterPressed) {
                event.cancelBubble = true;
                event.preventDefault();
                event.stopPropagation();
            }
        };
    });
    //设置焦点变化监听事件
    RE.upadteEventListener(document, "selectionchange", function () {
        RE.backuprange();
    });
    //document.addEventListener("selectionchange", function() { RE.backuprange(); });
    //找到正文，获取换行事件和设置可编辑属性
    $('.M-Art-P').each(function () {
        $(this).attr('contentEditable', 'true');
        //RE.upadteEventListener(this,"keydown",function(){RE.textkeydown(event);});
        //RE.upadteEventListener(this,"paste",function(){RE.pasteContent(event);});
    });
}

// 更新事件绑定
RE.upadteEventListener = function (obj, event, fn) {
    obj.removeEventListener(event, fn);
    obj.addEventListener(event, fn);
}
//注入本地字体文件
RE.injectFontFace = function (html) {
    $('head').find('style').each(function () {
        var type = $(this).attr('name');
        if (type == 'androidFont') {
            $(this).remove();
        }
    });
    $('head').append(html);
}

RE.editorPlat = function (platform) {
    var editor = false;
    $('html').find('meta').each(function () {
        var name = $(this).attr('name');
        if (name == 'coverFrom') {
            var contents = $(this).attr('content').split('-');
            if (contents.length > 0) {
                var lastPlat = contents[contents.length - 1];
                if (lastPlat == platform) {

                } else {
                    $(this).attr('content', $(this).attr('content') + '-' + platform);
                }
            } else {
                $(this).attr('content', platform);
            }
            editor = true;
        }
    });
    if (editor == false) {
        $('head').append('<meta name="coverFrom" content="' + platform + '" />');
    }
}

//兼容方法--检查是否旧的章模板，若是则取出标题+内容并重载新模板
RE.checkMuBan = function () {
    $('.M-Chap-Temp').add('.M-Chap-Temp11').each(function () {
        //判断是否无限内容
        var isLimit = false;
        $(this).find('.M-Chap-Inner').each(function () {
            isLimit = true;
        });
        if (isLimit == true) {
            //有限模板取出内容
            var html = '<div class="M-ChapTitle-Temp M-ChapTitle-Temp0"><div class="M-ChapTitle-Inner"><p class="ArtH1" data-placeholder="replaceTitle">replaceTitle</p></div></div>replaceContent';
            //取出旧模板里的标题
            var chapName = '';
            var chapContent = '';
            $(this).find('.ArtH1').each(function () {
                chapName = $(this)[0].textContent;
            });
            //取出旧模板里的内容
            $(this).find('.ArtH1Des').each(function () {
                chapContent = chapContent + '<p class="M-Art-P" >' + this.textContent + '</p>';
            });
            $(this).find('.M-Art-P').each(function () {
                chapContent = chapContent + this.outerHTML;
            });
            $(this).find('.M-Chap-BgImg').each(function () {
                chapContent = chapContent + '<div class="M-Art-ImgGroup" id="new"><p class="M-Art-ImgBox">' + this.outerHTML + '</p></div><p class="M-Art-P" ></p>';
            });
            html = html.replace(new RegExp('replaceTitle', 'gm'), chapName).replace(new RegExp('replaceContent', 'gm'), chapContent);
            $(this).replaceWith(html);
        } else {
            //无限内容模板直接去掉外部标签就可以了
            var html = $(this).html();
            $(this).replaceWith(html);
        }
    });
}

RE.initChap = function (titleName, chapType ) {
    //移除所有事件
    $(document.body).off();
    //兼容方法--检查是否旧的章模板，若是则取出标题+内容并重载新模板
    RE.checkMuBan();
    //初始化编辑状态
    RE.editorPlat('android');
    try {
        //添加底部间距
        var inner = document.getElementsByClassName('M-Chap-Inner');
        if (inner.length > 0) {
            document.body.style = '';
        } else {
            $('body').css('padding-bottom', '2em').css('box-sizing', 'border-box');
        }
        //添加标题按钮
        if($('.M-ChapTitle-Temp,.M-SectionTitle-Temp').find('.Btn-Select-Template').length==0){
            $('.M-ChapTitle-Temp,.M-SectionTitle-Temp').append('<div class="M-Art-Template-Tools"><div class="Btn-Select-Template">标题背景</div></div>')
        }
        $(document.body).on("click", ".Btn-Select-Template", function (event) {
           window.do_question.selectTitle();//点击选择标题模板
        });
        var firstText = $("body").find(".M-Art-P,.M-Art-H1,.M-Art-H2,.M-Art-H3,.M-Art-Ul").eq(0);
        firstText.attr('contentEditable', 'true').focus();
        /*if (chapType == 'chap') {
            placeHolder = '提示:此处也可以不编写内容！！！';
        }
        var firstText = $("body").find(".M-Art-P,.M-Art-H1,.M-Art-H2,M-Art-H3,.M-Art-Ul").eq(0);
        if (firstText[0].textContent.length < 1) {
            firstText.html('<span style="color: #cdcdcd;">'+placeHolder+'</span>');
        }
        firstText.focus(function () {
            if(this.textContent==placeHolder){
                $(this).html('');
            }
        }).blur(function () {
            if ($(this).html().length < 1) {
                $(this).html(''<span style="color: #cdcdcd;">'+placeHolder+'</span>'');
            }
        });*/
    } catch (e) {
    }
    //初始化音频编辑
    RE.initAudio();
    $(document.body).on("click", ".M-Art-AudioConsole .M-EbookMaker-Tools .M-EbookMaker-BtnMoveUp", function (event) {
       //上移
       RE.upEvent(event,$(this).parents(".M-Art-AudioConsole"),$(this));
    });
    $(document.body).on("click", ".M-Art-AudioConsole .M-EbookMaker-Tools .M-EbookMaker-BtnMoveDown", function (event) {
       //下移
        RE.downEvent(event,$(this).parents(".M-Art-AudioConsole"),$(this));
    });
    $(document.body).on("click", ".M-Art-AudioConsole .M-EbookMaker-BtnDel", function (event) {
       //删除
        RE.deleteEvent(event,$(this).parents(".M-Art-AudioConsole"));
    });
    //初始化视频编辑
    RE.initVideo();
    $(document.body).on("click", ".M-Art-VideoBox", function () {
         if($(this).parents(".M-Art-VideoConsole").hasClass('M-Art-VideoConsole-SlideUp')){
            $(this).parents(".M-Art-VideoConsole").removeClass('M-Art-VideoConsole-SlideUp');
            var isSlide = 'false';
            var _this = $(this).parents(".M-Art-VideoConsole")[0];
            var top = _this.offsetTop ;
            var bottom = _this.offsetTop + _this.offsetHeight+40;
            setTimeout(function () {
                RE.bodyHeight('-1');
                window.do_question.slideEnd(''+top,''+bottom,''+isSlide);
            }, 200);
         }
    });
    $(document.body).on("click", ".M-EbookMaker-BtnSlideUp", function (event) {
       event.cancelBubble = true;
       event.preventDefault();
       event.stopPropagation();
       if(!$(this).parents(".M-Art-VideoConsole").hasClass('M-Art-VideoConsole-SlideUp')){
           $(this).parents(".M-Art-VideoConsole").addClass('M-Art-VideoConsole-SlideUp');
           $(this).parents(".M-Art-VideoConsole").find('video')[0].pause();
            var isSlide = 'true';
            var _this = $(this).parents(".M-Art-VideoConsole")[0];
            var top = _this.offsetTop  ;
            var bottom = _this.offsetTop + _this.offsetHeight+40;
            setTimeout(function () {
                RE.bodyHeight('-1');
                window.do_question.slideEnd(''+top,''+bottom,''+isSlide);
            }, 200);
       }
    });
    $(document.body).on("click", ".M-Art-VideoConsole .M-EbookMaker-Tools .M-EbookMaker-BtnMoveUp", function (event) {
       //上移
       RE.upEvent(event,$(this).parents(".M-Art-VideoConsole"),$(this));
    });
    $(document.body).on("click", ".M-Art-VideoConsole .M-EbookMaker-Tools .M-EbookMaker-BtnMoveDown", function (event) {
       //下移
        RE.downEvent(event,$(this).parents(".M-Art-VideoConsole"),$(this));
    });
    $(document.body).on("click", ".M-Art-VideoConsole .M-EbookMaker-BtnDel", function (event) {
       //删除
        RE.deleteEvent(event,$(this).parents(".M-Art-VideoConsole"));
    });
   //初始化导入网页内容的折叠展示与编辑显示
    RE.initImport();
    $(document.body).on("click", ".M-Art-ImportConsole .M-EbookMaker-Tools .M-EbookMaker-BtnMoveUp", function (event) {
       //上移
       event.cancelBubble = true;
       event.preventDefault();
       event.stopPropagation();
       RE.upEvent(event,$(this).parents(".M-Art-ImportConsole"),$(this));
    });
    $(document.body).on("click", ".M-Art-ImportConsole .M-EbookMaker-Tools .M-EbookMaker-BtnMoveDown", function (event) {
       //下移
       event.cancelBubble = true;
       event.preventDefault();
       event.stopPropagation();
        RE.downEvent(event,$(this).parents(".M-Art-ImportConsole"),$(this));
    });
    $(document.body).on("click", ".M-Art-ImportConsole .M-EbookMaker-BtnDel", function (event) {
       //删除
        event.cancelBubble = true;
        event.preventDefault();
        event.stopPropagation();
        RE.deleteEvent(event,$(this).parents(".M-Art-ImportConsole"));
    });
    $(document.body).on("click", ".M-Art-ImportConsole .M-EbookMaker-BtnEdit", function (event) {
       //编辑
       event.cancelBubble = true;
       event.preventDefault();
       event.stopPropagation();
       var tempId = "" + new Date().getTime();
       $(this).parents(".M-Art-ImportConsole").find('.M-Art-Import').attr('id',tempId);
       var html = $(this).parents(".M-Art-ImportConsole").find('.M-Art-Import').html();
       window.do_question.editImport(tempId,html);
    });
    $(document.body).on("click", ".M-Art-ImportConsole", function (event) {
       //编辑
       var tempId = "" + new Date().getTime();
       $(this).find('.M-Art-Import').attr('id',tempId);
       var html = $(this).find('.M-Art-Import').html();
       window.do_question.editImport(tempId,html);
    });
    //初始化图片编辑
    M_Art.init();
    $(document.body).find(".M-Art-P,.M-Art-H1,.M-Art-H2,.M-Art-H3,.M-Art-Ul,.TxtEditable").each(function () {
        $(this).attr('contentEditable', 'true');
    });
    //绑定全局事件
    $("body").off("keydown", ".M-Art-P,.M-Art-H1,.M-Art-H2,.M-Art-H3,.M-Art-Ul");
    $("body").off("input", ".M-Art-P,.M-Art-H1,.M-Art-H2,.M-Art-H3,.M-Art-Ul");
    $("body").off("paste", ".M-Art-P,.M-Art-H1,.M-Art-H2,.M-Art-H3,.M-Art-Ul");
    $(document.body).on("keydown", ".M-Art-P,.M-Art-H1,.M-Art-H2,.M-Art-H3,.M-Art-Ul,.TxtEditable", function () {
        RE.textkeydown(event);
    });
    $(document.body).on("input", function () {
        RE.textchange(event);
    });
    $(document.body).on("paste", ".ArtH2,.ArtH1,.TxtEditable", function () {
        RE.pasteText(event);
    });
    $(document.body).on("paste", ".M-Art-P,.M-Art-H1,.M-Art-H2,.M-Art-H3,.M-Art-Ul", function () {
        RE.pasteContent(event);
    });
    $('.ArtH1').each(function () {
        if(titleName!=''){
            $(this).html(titleName);
        }
        $(this).attr('contentEditable', 'true');
        $(this)[0].onkeydown = function (event) {
            var wasEnterPressed = (event.keyCode == '13');
            if (wasEnterPressed) {
                event.cancelBubble = true;
                event.preventDefault();
                event.stopPropagation();
            }
        };
    });
    $('.ArtH2').each(function () {
        if(titleName!=''){
            $(this).html(titleName);
        }
        $(this).attr('contentEditable', 'true');
        $(this)[0].onkeydown = function (event) {
            var wasEnterPressed = (event.keyCode == '13');
            if (wasEnterPressed) {
                event.cancelBubble = true;
                event.preventDefault();
                event.stopPropagation();
            }
        };
    });
    $('.ArtH1Des').each(function () {
        $(this).attr('contentEditable', 'true');
        var maxLength = $(this).attr('data-max-length');
        $(this)[0].onkeydown = function (event) {
            var wasEnterPressed = (event.keyCode == '13');
            if (wasEnterPressed) {
                event.cancelBubble = true;
                event.preventDefault();
                event.stopPropagation();
            }
            var length = $(this)[0].textContent.length;
        };
    });
    $(document.body).children().each(function(){
        //去除表情和特殊符号
        var afterHtml = RE.meshEmoji($(this).html());
        if (afterHtml != $(this).html()) {
            $(this).html(afterHtml);
        }
    });
    //初始化图片点击事件
     $(document.body).on("click", ".M-Chap-BgImg,.ImgEditable,.ImgBgEditable", function () {
            $(this).attr("id", "" + new Date().getTime());
            RE.maskClick($(this).attr("id"));
     });
    //设置焦点变化监听事件
    RE.upadteEventListener(document, "selectionchange", function () {
        RE.backuprange();
    });
    //设置超链接点击事件
    $('.M-Art-A').on("click", function () {
        $(this).attr("id", "" + new Date().getTime());
        RE.hrefClick($(this).attr("id"));
    });
    //设置导入网址链接的查看全部功能
    RE.setWebShowAll();
    $('.M-Art-Quote-ShowAll').die().live("click", function () {
        var con = $(this).parent()[0];
        var hide = con.getElementsByClassName('M-Art-Quote-HideArea')[0];
        if (!hide) {
        } else {
            var hideHeight = hide.offsetHeight;
            var locY = 0;
            if ($(hide).css('display') == 'none') {
                $(hide).css('display', 'block');
                $(this).html('收起');
                var locY = $(hide).offset().top;
            } else if ($(hide).css('display') == 'block') {
                $(hide).css('display', 'none');
                $(this).html('查看全文');
                var locY = $(this).offset().top;
                //$('body').css('height',parseInt(height-hideHeight));
            }
            var height2 = document.body.offsetHeight - hideHeight;
            //RE.callback('re-selection-height://','{"locY":"'+locY+'","bodyH":"'+height2+'"}');
            RE.bodyHeight('-1');
        }
    });
    document.execCommand('insertBrOnReturn', false, false);
    document.execCommand('defaultParagraphSeparator', false, 'p');
    document.execCommand('styleWithCSS', false, false);
    //给第一个文本段加一个提示
    RE.checkEmpty();
    //初始化MutationJS实现撤销恢复操作
    try {
        window.mu = new nono.MutationJs();
        mu.disconnect();
        mu.reObserve();
    } catch (e) {}
    //返回当前页面的高度
    setTimeout(function () {
        RE.bodyHeight('-1');
    }, 200);
    //返回当前页面里图片的数量
    RE.logMediaCount();
    window.do_question.initEnd();
    //初始化完成，记录当前的Html,退出时比对是否有编辑过
    historyHtml = $(document.body).html();
}

//检查文本为空时，显示提示文字
RE.checkEmpty = function (){
    try {
        mu.disconnect();
    } catch (e) {}
    $('.M-Art-P-Active').removeClass('M-Art-P-Active').removeAttr('data-placeholder');
    var tags = $('body').children().not('.M-Art-P').not('.M-Art-H1').not('.M-Art-H2').not('.M-Art-H3').not('.M-Art-Ul').not('.M-ChapTitle-Temp').not('.M-SectionTitle-Temp');
    if(tags.length<1){
        var isEmpty = 'true';
        $("body").find(".M-Art-P,.M-Art-H1,.M-Art-H2,.M-Art-H3,.M-Art-Ul").each(function(){
           if(!RE.judgeBlank($(this))){
                isEmpty = 'false';
                return false;
           }
       });
       if(isEmpty=='true'){
            var firstText = $("body").find(".M-Art-P,.M-Art-H1,.M-Art-H2,.M-Art-H3,.M-Art-Ul").eq(0);
            firstText.addClass('M-Art-P-Active');
            firstText.attr('data-placeholder','请输入正文');
       }
    }
    try {
        mu.reObserve();
    } catch (e) {}
}

//删除
RE.deleteEvent = function (event,objTag){
    mu.disconnect();
    RE.deleteBlank();
    objTag.remove();
    RE.addBlank();
    RE.addBtnMoveDisabled();
    mu.reObserve();
    setTimeout(function () {
        RE.bodyHeight('-1');
    }, 200);
}

//判断能否上移
RE.canUpEvent  = function (obj){
    var preTab = obj.prev();
    while(preTab.length>0&&RE.judgeBlank(preTab)){
        preTab = preTab.prev();
    }
    if(preTab.find('.Btn-Select-Template').length>0){
        //上面是标题，不能上移了
        return false;
    }else{
        return true;
    }
}

//上移
RE.upEvent = function (event,moveTag,$_this){
    event.cancelBubble = true;
    event.preventDefault();
    event.stopPropagation();
    if (!$_this.hasClass('BtnMoveDisabled')) {
        if(!RE.canUpEvent(moveTag)){
            $_this.addClass('BtnMoveDisabled');
            return;
        }
        mu.disconnect();
        try {
            var lastText = $("body").find(".M-Art-P,.M-Art-H1,.M-Art-H2,.M-Art-H3,.M-Art-Ul").eq(-1);
            if (RE.isTextTag(lastText[0]) == true && RE.judgeBlank(lastText) == true) {
                lastText.html(' ');
            }
        } catch (e) {}
        RE.deleteBlank();
        moveTag.prev().css('opacity', 0.2);
        $('.M-EbookMaker-BtnMoveUp').addClass('BtnMoveDisabled');
        $('.M-EbookMaker-BtnMoveDown').addClass('BtnMoveDisabled');
        moveTag.prev().animate({'top': parseInt(moveTag.css('height'))}, 400, 'swing', function () {
            $(this).css({'top': 0, 'opacity': 1});
        });
        moveTag.animate({'top': -parseInt(moveTag.prev().css('height'))}, 400, 'swing', function () {
            $(this).css('top', 0);
            $(this).insertBefore(moveTag.prev());
            RE.addBlank();
            try {
                var lastText = $("body").find(".M-Art-P,.M-Art-H1,.M-Art-H2,.M-Art-H3,.M-Art-Ul").eq(-1);
                RE.logger('检查文本', lastText[0].textContent);
                if (lastText[0].textContent == ' ') {
                    lastText.html('');
                }
            } catch (e) {

            }
            RE.addBtnMoveDisabled();
            RE.bodyHeight('-1');
        });
        setTimeout(function () {
            mu.reObserve();
        }, 400);
    }
}

//判断能否下移
RE.canDownEvent  = function (obj){
    while(obj.next().length>0&&RE.judgeBlank(obj.next())){
        obj = obj.next();
    }
    if(obj.next().length ==0 || RE.judgeBlank(obj.next())){
        //后面全是空行，不能下移了
        return false;
    }else{
        return true;
    }
}

//下移
RE.downEvent = function (event,moveTag,$_this) {
    event.cancelBubble = true;
    event.preventDefault();
    event.stopPropagation();
    if (!$_this.hasClass('BtnMoveDisabled')) {
        if(!RE.canDownEvent(moveTag)){
            $_this.addClass('BtnMoveDisabled');
            return;
        }
        mu.disconnect();
        try {
            var lastText = $("body").find(".M-Art-P,.M-Art-H1,.M-Art-H2,.M-Art-H3,.M-Art-Ul").eq(-1);
            if (RE.isTextTag(lastText[0]) == true && RE.judgeBlank(lastText) == true) {
                lastText.html(' ');
            }
        } catch (e) {

        }
        RE.deleteBlank();
        moveTag.next().css('opacity', 0.2);
        $('.M-EbookMaker-BtnMoveUp').addClass('BtnMoveDisabled');
        $('.M-EbookMaker-BtnMoveDown').addClass('BtnMoveDisabled');
        moveTag.next().animate({'top': -parseInt(moveTag.css('height'))}, 400, 'swing', function () {
            $(this).css({'top': 0, 'opacity': 1});
        });
        moveTag.animate({'top': parseInt(moveTag.next().css('height'))}, 400, 'swing', function () {
            $(this).css('top', 0);
            moveTag.insertAfter(moveTag.next());
            RE.addBlank();
            try {
                var lastText = $("body").find(".M-Art-P,.M-Art-H1,.M-Art-H2,.M-Art-H3,.M-Art-Ul").eq(-1);
                RE.logger('检查文本', lastText[0].textContent);
                if (lastText[0].textContent == ' ') {
                    lastText.html('');
                }
            } catch (e) {

            }
            RE.addBtnMoveDisabled();
            RE.bodyHeight('-1');
        });
        setTimeout(function () {
            mu.reObserve();
        }, 400);
    }
}

//禁用上移下移按钮
RE.addBtnMoveDisabled = function () {
    $('.M-EbookMaker-BtnMoveUp').removeClass('BtnMoveDisabled');
    $('.M-EbookMaker-BtnMoveDown').removeClass('BtnMoveDisabled');
    var firstTab = $('body').find('.M-Art-ImgGroup,.M-Art-VideoConsole,.M-Art-AudioConsole,.M-Art-ImportConsole').eq(0);
    if(firstTab.length>0&&!RE.canUpEvent(firstTab)){
        firstTab.find(".M-EbookMaker-BtnMoveUp").addClass('BtnMoveDisabled');
    }
    var lastTab = $('body').find('.M-Art-ImgGroup,.M-Art-VideoConsole,.M-Art-AudioConsole,.M-Art-ImportConsole').eq(-1);
    if(lastTab.length>0&&!RE.canDownEvent(lastTab)){
        lastTab.find(".M-EbookMaker-BtnMoveDown").addClass('BtnMoveDisabled');
    }
}

// 添加空白行
RE.addBlank =function () {
    $('body').children().not('.M-Art-P').not('.M-Art-H1').not('.M-Art-H2').not('.M-Art-H3').not('.M-Art-Ul').each(function () {
        if ($(this).index()>0&&!$(this).prev('.M-Art-P').length && !$(this).prev('.M-Art-H1').length && !$(this).prev('.M-Art-H2').length&& !$(this).prev('.M-Art-H3').length && !$(this).prev('.M-Art-Ul').length) {
            $(this).before('<p class="M-Art-P" contenteditable="true"></p>');
        }
        if (!$(this).next('.M-Art-P').length && !$(this).next('.M-Art-H1').length && !$(this).next('.M-Art-H2').length&& !$(this).prev('.M-Art-H3').length  && !$(this).next('.M-Art-Ul').length) {
            $(this).after('<p class="M-Art-P" contenteditable="true"></p>');
        }
    })
}

// 删除空白行
RE.deleteBlank = function () {
    $("body").find(".M-Art-P,.M-Art-H1,.M-Art-H2,.M-Art-H3,.M-Art-Ul").each(function () {
        if ($(this).index()>0&&RE.judgeBlank($(this)))
            $(this).remove();
    })
}

// 判断空白行
RE.judgeBlank = function (obj) {
    if (obj.text() == '' && RE.isTextTag(obj[0]) == true && obj.find('img').length == 0) return true;
    else return false;
}

RE.logMediaCount = function (){
    window.do_question.logMediaCount($(".M-Art-ImgGroup,.ImgEditable,.ImgBgEditable,.M-Art-VideoBox").length);
}

RE.getBodyInnerHeight = function () {
    var lastObj = $('body').children().last();
    var innerHeight = parseInt(lastObj.offset().top) + parseInt(lastObj[0].offsetHeight);
    if (innerHeight > 0) {
        return innerHeight;
    } else {
        return 0;
    }
}

RE.bodyHeight = function (locY) {
    var height2 = RE.getBodyInnerHeight() + 40 ;
    window.do_question.selectionHeight(''+height2, ''+locY);
}

RE.hrefClick = function (tagId) {
    var obj = document.getElementById(tagId);
    var href = obj.href.toString();
    var title = obj.textContent;
    //RE.callback('re-hrefclick://','{"tagId":"'+tagId+'","href":"'+href+'","title":"'+title+'"}');
    window.do_question.hrefClick(tagId, href, title);
}

RE.updateMask = function (tagId, url) {
    mu.disconnect();
    var mask = document.getElementById(tagId);
    mask.src = url;
    var parent = mask.parentNode;
    $(parent).css('background-image', 'url(' + url + ')');
    mu.reObserve();
}

RE.updateImage = function (tagId, url) {
    //换图，美图
    mu.disconnect();
    var image = document.getElementById(tagId);
    image.src = url;
    image.removeAttribute('id');
    //如果是本地图片，则显示上传
    if (url.toLowerCase().indexOf('file://') >= 0) {
        $(image).parents(".M-Art-ImgGroup").find('.M-EbookMaker-UploadIng').css('display','block');
        $(image).parents(".M-Art-ImgGroup").find('.M-EbookMaker-UploadFail').css('display','none');
    }
    mu.reObserve();
}

RE.maskClick = function (tagId) {
    //点击图片的事件
    var mask = document.getElementById(tagId);
    var src = mask.getAttribute('src');
    var parent = mask.parentNode;
    var _top = 0, _left = 0;
    var width = parent.offsetWidth - parseInt($(parent).css('paddingLeft')) - parseInt($(parent).css('paddingRight'));
    var height = parent.offsetHeight - parseInt($(parent).css('paddingTop')) - parseInt($(parent).css('paddingBottom'));
    _top += parseInt($(mask).offset().top);
    _left += parseInt($(mask).offset().left);
    RE.callback('re-maskclick://', '{"tagId":"' + tagId + '","src":"' + src + '","top":' + _top + ',"left":' + _left + ',"width":' + width + ',"height":' + height + '}');
}

RE.textkeypress = function (event) {
    var wasEnterPressed = (event.keyCode == '13');
}

RE.isTextTag = function (obj) {
    //判断该标签是否正文
    if (obj.nodeName.toLowerCase() == 'p' && (obj.className.indexOf('M-Art-P') >= 0 || obj.className.indexOf('M-Art-H2') >= 0 || obj.className.indexOf('M-Art-H1') >= 0|| obj.className.indexOf('M-Art-H3') >= 0)) {
        return true;
    } else if (obj.nodeName.toLowerCase() == 'ul' && obj.className.indexOf('M-Art-Ul') >= 0) {
        return true;
    } else {
        return false;
    }
}

RE.pasteText = function (eve) {
    //监听粘贴事件，修改剪切板内容
    eve.preventDefault();
    eve.stopPropagation();
    window.do_question.pasteText();
}

RE.pasteContent = function (eve) {
    //监听粘贴事件，修改剪切板内容
    eve.preventDefault();
    eve.stopPropagation();
    window.do_question.pasteContent();
}

RE.meshEmoji = function (html) {
    //格式化html，去除输入法自带表情和特殊符号
    var obj = $('<div>' + html + '</div>')[0];
    for (var i = 0; i < obj.childNodes.length; i++) {
        var child= obj.childNodes[i];
        if(child.childNodes.length>0){
            //还有子标签，继续判断
            var htmlInner = RE.meshEmoji($(child).html());
            $(child).html(htmlInner);
        }else {
            var afterText = RE.checkEmojiContext(child.textContent);
            if (afterText != child.textContent) {
                child.textContent = afterText;
            }
        }
    }
    return $(obj).html();
}

RE.checkEmojiContext = function (text) {
    //格式化文字，去除输入法自带表情和特殊符号
    var patt = /[\ud800-\udbff][\udc00-\udfff]|[\u20d0-\u20ff]|[\u2300-\u23ff]|[\u25a0-\u27bf]|[\u2b00-\u2bff]/g;
    // 检测utf16字符正则
    var str = text.replace(patt, function (char) {
        var H, L, code;
        if (char.length === 2) {
            //H = char.charCodeAt(0);
            //// 取出高位
            //L = char.charCodeAt(1);
            //// 取出低位
            //code = (H - 0xD800) * 0x400 + 0x10000 + L - 0xDC00;
            //// 转换算法
            //RE.logger("转换算法",""+H+L);
            return '';
        } else if (char.length === 1) {
            //RE.logger("转换算法",""+char.charCodeAt(0));
            return '';
        } else {
            return char;
        }
    });
    return str;
}

RE.textchange = function (event) {
    event.preventDefault();
    event.stopPropagation();
    //格式化输入的标签类型：标题里只允许输入文字，正文里不允许P标签嵌套
    var node = document.activeElement;
    if($(node).hasClass('ArtH2')||$(node).hasClass('ArtH1')){
        //格式化标题，只允许输入文字
        $(node).children().not('text').each(function () {
            if(this.textContent){
                $(this).replaceWith(this.textContent);
            }else{
                $(this).remove();
            }
        });
    }
    if(RE.isTextTag(node)==true){
        //格式化正文，只允许文字、span、img、ul、a标签，不允许P标签嵌套
        $(node).children().not('text').not('span').not('img').not('ul').not('a').each(function () {
            if(this.textContent){
                $(this).replaceWith(this.textContent);
            }else{
                $(this).remove();
            }
        });
    }
    //拦截输入法自带的表情和特殊符号
    var selection = window.getSelection();
    var afterText = RE.checkEmojiContext(selection.focusNode.textContent);
    if (afterText == selection.focusNode.textContent) {
        return;
    }
    mu.disconnect();
    document.execCommand('Delete');
    mu.reObserve();
}

RE.textkeydown = function (eve) {
    //监听编辑文本的软键盘事件
    try {
        RE.logger("按键", eve.which);
        var wasEnterPressed = (eve.keyCode == '13');
        if (wasEnterPressed) {
            if (document.activeElement.nodeName.toLowerCase() == 'ul'||RE.isTextTag(document.activeElement) == false) {
                return;
            }
            //拦截回车按键，新增段落
            event.cancelBubble = true;
            event.preventDefault();
            event.stopPropagation();
            var selection = window.getSelection();
            var range = selection.getRangeAt(0);
            var htmlBefore = '';
            var htmlAfter = '';
            var comm = range.startContainer;
            if (RE.isTextTag(comm) == true) {
                //点中标签外部
                for (var i = 0; i < comm.childNodes.length; i++) {
                    if (range.startOffset > i) {
                        htmlBefore += RE.getHtml(comm.childNodes[i]);
                    } else {
                        htmlAfter += RE.getHtml(comm.childNodes[i]);
                    }
                }
            } else {
                var chooseObj = range.startContainer.parentNode;
                if (RE.isTextTag(chooseObj) == true) {
                    //没有选中标签
                    var check = false;
                    for (var i = 0; i < chooseObj.childNodes.length; i++) {
                        var obj = chooseObj.childNodes[i];
                        RE.logger(obj.nodeName, RE.getHtml(obj));
                        if (obj == comm) {
                            check = true;
                            htmlBefore += RE.getHtmlBefore(obj, range.startOffset);
                            htmlAfter += RE.getHtmlAfter(obj, range.startOffset);
                        } else {
                            if (check) {
                                htmlAfter += RE.getHtml(obj);
                            } else {
                                htmlBefore += RE.getHtml(obj);
                            }
                        }
                    }
                } else {
                    //选中了标签
                    var check = false;
                    for (var i = 0; i < chooseObj.childNodes.length; i++) {
                        var obj = chooseObj.childNodes[i];
                        RE.logger(obj.nodeName, RE.getHtml(obj));
                        if (obj == comm) {
                            check = true;
                            htmlBefore += RE.getHtmlBefore(obj, range.startOffset);
                            htmlAfter += RE.getHtmlAfter(obj, range.startOffset);
                        } else {
                            if (check) {
                                htmlAfter += RE.getHtml(obj);
                            } else {
                                htmlBefore += RE.getHtml(obj);
                            }
                        }
                    }
                    while (RE.isTextTag(chooseObj) == false) {
                        var inner = $(chooseObj).html();
                        $(chooseObj).html(htmlAfter);
                        htmlAfter = chooseObj.outerHTML;
                        $(chooseObj).html(htmlBefore);
                        htmlBefore = chooseObj.outerHTML;
                        $(chooseObj).html(inner);
                        comm = chooseObj;
                        chooseObj = chooseObj.parentNode;
                        check = false;
                        var beforeHtml = '';
                        var afterHtml = '';
                        for (var j = 0; j < chooseObj.childNodes.length; j++) {
                            var objj = chooseObj.childNodes[j];
                            //RE.logger(objj.nodeName,RE.getHtml(objj));
                            if (objj == comm) {
                                check = true;
                                //htmlBefore+=RE.getHtmlBefore(obj,range.startOffset);
                                //htmlAfter+=RE.getHtmlAfter(obj,range.startOffset);
                            } else {
                                if (check) {
                                    afterHtml += RE.getHtml(objj);
                                } else {
                                    beforeHtml += RE.getHtml(objj);
                                }
                            }
                        }
                        htmlAfter += afterHtml;
                        htmlBefore = beforeHtml + htmlBefore;
                    }
                }
            }
            var fatherNode = document.activeElement;
            var paragraph = document.createElement('p');
            var textNode = document.createTextNode('新的一段');
            paragraph.appendChild(textNode);
            paragraph.className = $(fatherNode).attr('class');
            paragraph.contentEditable = true;
            //RE.upadteEventListener(paragraph,"keydown", function(){RE.textkeydown(event);});
            //paragraph.addEventListener("keydown",function(){RE.textkeydown(event);});
            //paragraph.addEventListener("keypress",function(){RE.textkeypress(event);});
            $(fatherNode).after(paragraph);
            htmlBefore = RE.meshHtml(htmlBefore);
            htmlAfter = RE.meshHtml(htmlAfter);
            $(fatherNode).html(htmlBefore);
            $(paragraph).html(htmlAfter);
            paragraph.focus();
        }
        var wasEnterBack = (eve.keyCode == '8');
        if (wasEnterBack) {
            //处理回退事件，当到段落起始位置时执行合并/删除标签
            var selection = window.getSelection();
            var range = selection.getRangeAt(0);
            if($(document.activeElement).hasClass('TxtEditable')&&RE.isBackToTop(range)&&$(document.activeElement).children().length<=1){
                //拦截删除按钮，禁止删除P标签
                event.cancelBubble = true;
                event.preventDefault();
                event.stopPropagation();
            }
            if (RE.isBackTop(range)&&RE.isTextTag(document.activeElement)) {
                //if(range.startOffset==range.endOffset&&range.startOffset==0){
                //拦截回退按键
                event.cancelBubble = true;
                event.preventDefault();
                event.stopPropagation();
                var fatherNode = document.activeElement;
                var preObj = fatherNode.previousSibling;
                if (preObj != null) {
                    if (RE.isTextTag(preObj) == true) {
                        //上一个标签是文本，进行文本合并

                        if (preObj.lastChild != null && preObj.lastChild.nodeName.toLowerCase() == '#text') {
                            var textSpan = document.createElement('span');
                            $(textSpan).html(preObj.lastChild.textContent);
                            preObj.removeChild(preObj.lastChild);
                            preObj.insertAdjacentHTML('beforeEnd', textSpan.outerHTML);
                        }
                        if (fatherNode.nodeName.toLowerCase() == preObj.nodeName.toLowerCase()) {
                            var length=$(fatherNode).html().length;
                            if(length==0){
                                if($(preObj).html().length>0){
                                    RE.insertHTML($(preObj).html());
                                }
                            }else{
                                fatherNode.insertAdjacentHTML('afterBegin', $(preObj).html());
                            }
                        } else {
                            if (fatherNode.nodeName.toLowerCase() == 'ul') {
                                fatherNode.insertAdjacentHTML('afterBegin', '<li>' + $(preObj).html() + '</li>');
                            } else {
                                if (preObj.lastChild != null && preObj.lastChild.nodeName.toLowerCase() == 'li') {
                                    if (preObj.lastChild.lastChild != null && preObj.lastChild.lastChild.nodeName.toLowerCase() == '#text') {
                                        var textSpan = document.createElement('span');
                                        $(textSpan).html(preObj.lastChild.lastChild.textContent);
                                        preObj.removeChild(preObj.lastChild.lastChild);
                                        preObj.insertAdjacentHTML('beforeEnd', textSpan.outerHTML);
                                    }
                                }
                                for (var i = 0; i < preObj.childNodes.length; i++) {
                                    if (preObj.childNodes[i].nodeName.toLowerCase() == 'li') {
                                        $(preObj.childNodes[i]).replaceWith($(preObj.childNodes[i]).html());
                                    }
                                }
                                fatherNode.insertAdjacentHTML('afterBegin', $(preObj).html());
                            }
                        }
                        $(preObj).remove();
                    } else {
                        //删除上一个标签
                        if (!preObj.className || (preObj.className.indexOf('ArtH1') < 0 && preObj.className.indexOf('ArtH2') < 0 && preObj.className.indexOf('M-SectionTitle-Temp') < 0 && preObj.className.indexOf('M-ChapTitle-Temp') < 0&& preObj.className.indexOf('M-Art-View-Title') < 0)) {
                            //标题不允许删除
                            $(preObj).remove();
                        }
                    }
                }
            }else{
                //如果前面有\ufeff特殊字符，则批量处理掉

            }
            RE.backuprange();
        }
    } catch (e) {
    }
}

RE.meshHtml = function (html) {
    //格式化html，去除无用和非法的标签
    var obj = $('<p>' + html + '</p>')[0];
    for (var i = 0; i < obj.childNodes.length; i++) {
        if(obj.childNodes[i].nodeName.toLowerCase()=='br'){
            //删除br标签
            $(obj.childNodes[i]).remove();
            i--;
        }
        else if(obj.childNodes[i].nodeName.toLowerCase()=='span'){
            if(obj.childNodes[i].childNodes.length>0){
                //还有子标签，继续判断
                $(obj.childNodes[i]).html(RE.meshHtml($(obj.childNodes[i]).html()));
            }else if(obj.childNodes[i].textContent.length==0){
                //删除空的span
                $(obj.childNodes[i]).remove();
                i--;
            }

        }
        else if(obj.childNodes[i].nodeName.toLowerCase()=='li'){
            $(obj.childNodes[i]).html(RE.meshHtml($(obj.childNodes[i]).html()));
        }
    }
    return $(obj).html();
}

RE.isBackToTop = function (range) {
    //禁止删除图文的P标签
    if (range.startOffset != range.endOffset || range.startOffset != 0) {
            return false;
    }else{
        if (range.startContainer.previousElementSibling == null) {
            if (range.startContainer.nodeName.toLowerCase() == 'p'&& range.startOffset == 0) {
                for(var i=0;i<range.startContainer.childNodes.length;i++){
                    //删除掉多余的br标签
                    if(range.startContainer.childNodes[i].nodeName.toLowerCase() == 'br'){
                        $(range.startContainer.childNodes[i]).remove();
                    }
                }
                return true;
            }
            else {
                return false;
            }
        }else{
            return false;
        }
    }
}


RE.isBackTop = function (range) {
    //去除光标前冗余的标签
    if (range.startOffset != range.endOffset || range.startOffset != 0) {
        return false;
    } else {
        if (range.startContainer.previousSibling != null) {
            if (range.startContainer.previousSibling.nodeName.toLowerCase() == 'p' || range.startContainer.previousSibling.nodeName.toLowerCase() == 'ul' || range.startContainer.previousSibling.nodeName.toLowerCase() == 'div') {
                return true;
            }
            else {
                $(range.startContainer.previousSibling).remove();
                return false;
            }
        } else {
            var index = RE.getSpanIndex(range.startContainer.parentNode);
            var newSpan = range.startContainer.parentNode;
            while ((newSpan.parentNode.nodeName.toLowerCase() == 'span' || newSpan.parentNode.nodeName.toLowerCase() == 'li') && index <= 0) {
                var parent = newSpan.parentNode;
                index = RE.getSpanIndex(parent);
                newSpan = parent;
            }
            if (range.startContainer.parentNode.nodeName.toLowerCase() == 'li' && index > 0) {
                return false;
            }
            else if (range.startContainer.parentNode.nodeName.toLowerCase() == 'span' && index > 0) {
                return false;
            }
            else {
                return true;
            }
        }
    }
}

RE.getHtml = function (node) {
    //获取节点的html内容
    if (node.nodeName.toLowerCase() == '#text') {
        //文本标签
        return node.textContent;
    } else {
        return node.outerHTML;
    }
}

RE.getHtmlBefore = function (node, index) {
    //获取选中节点前的html内容
    if (node.nodeName.toLowerCase() == '#text') {
        //文本标签
        return node.textContent.substring(0, index);
    } else {
        var before = '';
        for (var i = 0; i < node.childNodes.length; i++) {
            if (i < index) {
                if (node.childNodes[i].nodeName.toLowerCase() == '#text') {
                    before += node.childNodes[i].textContent;
                } else {
                    before += node.childNodes[i].outerHTML;
                }
            }
        }
        if (before.length > 0) {
            var obj = $(node.outerHTML);
            obj.html(before);
            return obj[0].outerHTML;
        } else {
            return '';
        }
    }
}

RE.getHtmlAfter = function (node, index) {
    //获取选中节点后的html内容
    if (node.nodeName.toLowerCase() == '#text') {
        //文本标签
        return node.textContent.substring(index, node.length);
    } else {
        var after = '';
        for (var i = 0; i < node.childNodes.length; i++) {
            if (index <= i) {
                if (node.childNodes[i].nodeName.toLowerCase() == '#text') {
                    after += node.childNodes[i].textContent;
                } else {
                    after += node.childNodes[i].outerHTML;
                }
            }
        }
        if (after.length > 0) {
            var obj = $(node.outerHTML);
            obj.html(after);
            return obj[0].outerHTML;
        } else {
            return '';
        }
    }
}

RE.updateLink = function (tagId, url, name) {
    //修改超链接属性
    mu.disconnect();
    var obj = document.getElementById(tagId);
    $(obj).attr('href', url);
    $(obj).attr('title', name);
    $(obj).html(name);
    mu.reObserve();
}

RE.execCommand = function (method) {
    //执行execCommand方法
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
        document.execCommand(method);
    }
}

RE.insertTEXT= function (html) {
    //在当前光标位置插入一段文字
    try {
        var selection = window.getSelection();
        if (selection.rangeCount > 0) {
            var range = selection.getRangeAt(0);
            range.collapse(false);
            var hasR = range.createContextualFragment(html);
            var hasR_lastChild = hasR.lastChild;
            range.insertNode(hasR);
            if (hasR_lastChild) {
                range.setEndAfter(hasR_lastChild);
                range.setStartAfter(hasR_lastChild);
            }
            selection.removeAllRanges();
            selection.addRange(range);
        }
    } catch (e) {

    }
}

RE.insertHTML = function (html) {
    //在当前光标位置插入一段html
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        //document.execCommand('insertHTML', false, html);
        range.collapse(false);
        var hasR = range.createContextualFragment(html);
        var hasR_lastChild = hasR.lastChild;
        while (hasR_lastChild && hasR_lastChild.nodeName.toLowerCase() == "br" && hasR_lastChild.previousSibling && hasR_lastChild.previousSibling.nodeName.toLowerCase() == "br") {
            var e = hasR_lastChild;
            hasR_lastChild = hasR_lastChild.previousSibling;
            hasR.removeChild(e);
        }
        if (hasR_lastChild.nodeName.toLowerCase() == 'a' && range.startContainer.parentNode.nodeName.toLowerCase() == 'a') {
            var parent = range.startContainer.parentNode;
            $(parent).replaceWith(html);

        } else {
            range.insertNode(hasR);
            if (hasR_lastChild) {
                range.setEndAfter(hasR_lastChild);
                range.setStartAfter(hasR_lastChild);
            }
            selection.removeAllRanges();
            selection.addRange(range);
        }
    }
}

RE.addHTML = function (html, type) {
    //在当前光标位置下面插入一段html
    //新增段落
    mu.disconnect();
    var selection = window.getSelection();
    var range = selection.getRangeAt(0);
    var htmlBefore = '';
    var htmlAfter = '';
    var comm = range.startContainer;
    if (RE.isTextTag(comm) == true) {
        //点中标签外部
        for (var i = 0; i < comm.childNodes.length; i++) {
            if (range.startOffset > i) {
                htmlBefore += RE.getHtml(comm.childNodes[i]);
            } else {
                htmlAfter += RE.getHtml(comm.childNodes[i]);
            }
        }
    } else {
        var chooseObj = range.startContainer.parentNode;
        if (RE.isTextTag(chooseObj) == true) {
            //没有选中标签
            var check = false;
            for (var i = 0; i < chooseObj.childNodes.length; i++) {
                var obj = chooseObj.childNodes[i];
                RE.logger(obj.nodeName, RE.getHtml(obj));
                if (obj == comm) {
                    check = true;
                    htmlBefore += RE.getHtmlBefore(obj, range.startOffset);
                    htmlAfter += RE.getHtmlAfter(obj, range.startOffset);
                } else {
                    if (check) {
                        htmlAfter += RE.getHtml(obj);
                    } else {
                        htmlBefore += RE.getHtml(obj);
                    }
                }
            }
        } else {
            //选中了标签
            var check = false;
            for (var i = 0; i < chooseObj.childNodes.length; i++) {
                var obj = chooseObj.childNodes[i];
                RE.logger(obj.nodeName, RE.getHtml(obj));
                if (obj == comm) {
                    check = true;
                    htmlBefore += RE.getHtmlBefore(obj, range.startOffset);
                    htmlAfter += RE.getHtmlAfter(obj, range.startOffset);
                } else {
                    if (check) {
                        htmlAfter += RE.getHtml(obj);
                    } else {
                        htmlBefore += RE.getHtml(obj);
                    }
                }
            }
            while (RE.isTextTag(chooseObj) == false) {
                var inner = $(chooseObj).html();
                $(chooseObj).html(htmlAfter);
                htmlAfter = chooseObj.outerHTML;
                $(chooseObj).html(htmlBefore);
                htmlBefore = chooseObj.outerHTML;
                $(chooseObj).html(inner);
                comm = chooseObj;
                chooseObj = chooseObj.parentNode;
                check = false;
                var beforeHtml = '';
                var afterHtml = '';
                for (var j = 0; j < chooseObj.childNodes.length; j++) {
                    var objj = chooseObj.childNodes[j];
                    RE.logger(objj.nodeName, RE.getHtml(objj));
                    if (objj == comm) {
                        check = true;
                        //htmlBefore+=RE.getHtmlBefore(obj,range.startOffset);
                        //htmlAfter+=RE.getHtmlAfter(obj,range.startOffset);
                    } else {
                        if (check) {
                            afterHtml += RE.getHtml(objj);
                        } else {
                            beforeHtml += RE.getHtml(objj);
                        }
                    }
                }
                htmlAfter += afterHtml;
                htmlBefore = beforeHtml + htmlBefore;
            }
        }
    }
    var fatherNode = document.activeElement;
    //var paragraph = document.createElement('p');
    //var textNode = document.createTextNode('新的一段');
    //paragraph.appendChild(textNode);
    //paragraph.className = 'M-Art-P';
    //paragraph.contentEditable = true;
    var newTextP=fatherNode.outerHTML.replace($(fatherNode).html(),'');
    var paragraph = $(newTextP)[0];
    //RE.upadteEventListener(paragraph,"keydown", function(){RE.textkeydown(event);});
    //paragraph.addEventListener("keydown",function(){RE.textkeydown(event);});
    //paragraph.addEventListener("keypress",function(){RE.textkeypress(event);});
    $(fatherNode).after(paragraph);
    $(fatherNode).html(htmlBefore);
    $(paragraph).html(htmlAfter);
    paragraph.insertAdjacentHTML('beforeBegin', html);
    /*paragraph.focus();*/
    if (type == 'web') {
        //设置导入网址链接的查看全部功能
        RE.setWebShowAll();
    } else if (type == 'media' || type == 'paste') {
        //设置文本的编辑事件
        $('.M-Art-P,.M-Art-H1,.M-Art-H2,.M-Art-H3,.M-Art-Ul,.TxtEditable').each(function () {
            $(this).attr('contentEditable', 'true');
            //RE.upadteEventListener(this,"keydown", function(){RE.textkeydown(event);});
            //$(this)[0].addEventListener("keydown",function(){RE.textkeydown(event);});
        });
        $('.M-Art-ImgGroup').each(function () {
            if ($(this).attr('id') == 'new') {
                $(this).attr('id', '');
                M_Art.newImg($(this).find('.M-Art-ImgBox'),true);
            }
        });
        RE.initAudio();
        RE.initVideo();
    } else if (type == 'imagetext') {
        //设置图文素材的操作事件
        $('.M-Art-P').each(function () {
            $(this).attr('contentEditable', 'true');
            //RE.upadteEventListener(this,"keydown", function(){RE.textkeydown(event);});
        });
        $(".TxtEditable").each(function () {
            $(this).attr('contenteditable', 'true');
        });
    }  else if(type == 'import'){
        //导入的可编辑内容
        RE.setWebShowAll();
        RE.initImport();
        $('.M-Art-P,.M-Art-H1,.M-Art-H2,.M-Art-H3,.M-Art-Ul,.TxtEditable').each(function () {
            $(this).attr('contentEditable', 'true');
        });
        $('.M-Art-ImgGroup').each(function () {
            if ($(this).attr('id') == 'new') {
                $(this).attr('id', '');
                M_Art.newImg($(this).find('.M-Art-ImgBox'),true);
            }
        });
        RE.initAudio();
        RE.initVideo();
    }
    RE.addBtnMoveDisabled();
    RE.logMediaCount();
    mu.reObserve();
    setTimeout(function () {
        paragraph.focus();
    }, 200);
}
RE.replaceImage =  function (id , src , width ,height) {
    //上传成功，替换文件地址
    mu.disconnect();
    var $image = $(document.body).find("[src='" + id + "']");
    $image.attr('src', src);
    $image.attr('data-width', parseInt(width));
    $image.attr('data-height', parseInt(height));
    $image.parent().find('.M-EbookMaker-UploadIng,.M-EbookMaker-UploadFail').css('display','none');
    mu.reObserve();
}

RE.uploadFalse =  function (id) {
    //上传失败，显示失败按钮
    mu.disconnect();
    var $image = $(document.body).find("[src='" + id + "']");
    $image.parent().find('.M-EbookMaker-UploadIng').css('display','none');
    $image.parent().find('.M-EbookMaker-UploadFail').css('display','block');
    $image.parent().find('.M-EbookMaker-UploadTips-Percent').html('0%');
    mu.reObserve();
}

RE.uploadProgress =  function (id , progress) {
    //上传成功，替换文件地址
    mu.disconnect();
    var $image = $(document.body).find("[src='" + id + "']");
    $image.parent().find('.M-EbookMaker-UploadTips-Percent').html(progress+'%');
    mu.reObserve();
}

RE.setWebShowAll = function () {
    //设置导入网址链接的查看全部功能
    $('.M-Art-Quote-HideArea').parent().each(function () {
        var hide = $(this)[0].getElementsByClassName('M-Art-Quote-ShowAll');
        if (hide.length <= 0) {
            aTab = document.createElement('a');
            aTab.className = 'M-Art-Quote-ShowAll';
            $(aTab).html('查看全文');
            aTab.href = 'javascript:void(0)';
            $(this)[0].appendChild(aTab);
        }
    });
}

/*修改导入模块的内容*/
RE.updateImport = function(id,html){
    $(document.body).find("[id='" + id + "']").each(function () {
        $(this).html(html.replace(new RegExp('&comma', 'gm'), ',').replace(new RegExp('&quote', 'gm'), "'"));
        $(this).after('<span class="M-EbookMaker-BtnDel"></span>'
            +'<span class="M-EbookMaker-Tools" style="display:block;">'
            + '<span class="M-EbookMaker-BtnContianer">'
            + '<span class="MoveBtns">'
            + '<span class="M-EbookMaker-BtnMoveUp">上移</span>'
            + '<span class="M-EbookMaker-BtnMoveDown">下移</span>'
            + '</span>'
            + '<span class="M-EbookMaker-BtnEdit">编辑</span>'
            + '</span>'
            + '</span>');
        $(this).removeAttr('id');
    });
}

/*初始化导入网页内容的折叠展示与编辑显示*/
RE.initImport = function(){
    $(document.body).find(".M-Art-Import").each(function () {
        if(!$(this).parent().hasClass('M-Art-ImportConsole')){
            // 统一加工具框
            $(this).wrap('<div class="M-Art-ImportConsole M-Art-ImportConsole-Active"></div>');
        }
        if(!$(this).next().hasClass('M-EbookMaker-BtnDel')){
            $(this).after('<span class="M-EbookMaker-BtnDel"></span>'
                +'<span class="M-EbookMaker-Tools" style="display:block;">'
                + '<span class="M-EbookMaker-BtnContianer">'
                + '<span class="MoveBtns">'
                + '<span class="M-EbookMaker-BtnMoveUp">上移</span>'
                + '<span class="M-EbookMaker-BtnMoveDown">下移</span>'
                + '</span>'
                + '<span class="M-EbookMaker-BtnEdit">编辑</span>'
                + '</span>'
                + '</span>');
        }
    });
}

/*初始化音频标签工具栏*/
RE.initAudio = function(){
    $(document.body).find(".M-Art-AudioBox").each(function () {
        if($(this).parents().hasClass('M-Art-Import')){
            return true;
        }
        if(!$(this).parent().hasClass('M-Art-AudioConsole')){
            $(this).wrap('<div class="M-Art-AudioConsole"></div>');
        }
        // 统一加工具框
        $(this).parents(".M-Art-AudioConsole").addClass('M-Art-AudioConsole-Active');
        if(!$(this).next().hasClass('M-EbookMaker-BtnDel')){
            $(this).after('<span class="M-EbookMaker-BtnDel"></span>'
                +'<span class="M-EbookMaker-Tools" style="display:block;">'
                +'<span class="M-EbookMaker-BtnContianer">'
                +'<span class="MoveBtns"><span class="M-EbookMaker-BtnMoveUp">上移</span><span class="M-EbookMaker-BtnMoveDown">下移</span></span>'
                +'</span> </span>');
        }
    });
}

/*初始化视频标签工具栏*/
RE.initVideo = function(){
    $(document.body).find(".M-Art-VideoBox").each(function () {
        if($(this).parents().hasClass('M-Art-Import')){
            return true;
        }
        if(!$(this).parent().hasClass('M-Art-VideoConsole')){
            $(this).wrap('<div class="M-Art-VideoConsole"></div>');
        }
        // 统一加工具框
        $(this).parents(".M-Art-VideoConsole").addClass('M-Art-VideoConsole-Active M-Art-VideoConsole-SlideUp');
        if(!$(this).next().hasClass('M-EbookMaker-BtnDel')){
            $(this).after('<span class="M-EbookMaker-BtnDel"></span>'
                +'<span class="M-EbookMaker-Tools" style="display:block;">'
                +'<span class="M-EbookMaker-BtnContianer">'
                +'<span class="MoveBtns">'
                +'<span class="M-EbookMaker-BtnMoveUp">上移</span>'
                +'<span class="M-EbookMaker-BtnMoveDown">下移</span>'
                +'</span>'
                +'<span class="M-EbookMaker-BtnSlideUp">收起</span>'
                +'</span>'
                +'</span>');
        }
        //加背景
        var url = $(this).find('video').attr('poster');
        $(this).css('background-image', 'url(' + url + ')');
    });
}

RE.backuprange = function () {
    var classname = document.activeElement.className;
    if (classname.length <= 0) {
        RE.callback('re-selection://', '');
        return;
    }
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
        RE.checkEmpty();
        var range = selection.getRangeAt(0);
        RE.currentSelection = {
            "startContainer": range.startContainer,
            "startOffset": range.startOffset,
            "endContainer": range.endContainer,
            "endOffset": range.endOffset
        };
        //返回当前光标的高度
        var comm = range.startContainer;
        var top = 0;
        var bottom = 0;
        var locY = 0;
        if (comm.nodeName.toLowerCase() == '#text') {
            //文本标签
            if (comm.previousSibling != null) {
                //用previousSibling的bottom值
                if (comm.previousSibling.nodeName.toLowerCase() == '#text') {
                    $(comm.previousSibling).wrap('<span ></span>');
                }
                top = $(comm.previousSibling).offset().top + comm.previousSibling.offsetHeight;
            } else {
                //没有上一个兄弟标签，用parent的top值
                top = $(comm.parentNode).offset().top;
            }
            if (comm.nextSibling != null) {
                //用nextSibling的top值
                if (comm.nextSibling.nodeName.toLowerCase() == '#text') {
                    $(comm.nextSibling).wrap('<span ></span>');
                }
                bottom = $(comm.nextSibling).offset().top;
            } else {
                //没有下一个兄弟标签，用parent的bottom值
                bottom = $(comm.parentNode).offset().top + comm.parentNode.offsetHeight;
            }
            if (range.startContainer.length > 0) {
                var per = parseFloat('' + range.startOffset) / range.startContainer.length;
                locY = top + per * (bottom - top);
            } else {
                locY = top;
            }
        }
        else {
            //非文本标签
            if (range.startOffset > 0) {
                var index = range.startOffset - 1;
                var chooseObj = comm.childNodes[index];
                if (chooseObj.nodeName.toLowerCase() == '#text') {
                    if (chooseObj.nextSibling != null) {
                        //用nextSibling的top值
                        bottom = $(chooseObj.nextSibling).offset().top;
                    } else {
                        //没有下一个兄弟标签，用parent的bottom值
                        bottom = $(chooseObj.parentNode).offset().top + chooseObj.parentNode.offsetHeight;
                    }
                    locY = bottom;
                } else {
                    locY = $(chooseObj).offset().top + chooseObj.offsetHeight;
                }
            } else {
                locY = $(comm).offset().top;
            }
        }
        var height2 = document.body.offsetHeight;
        RE.callback('re-selection://', classname);
        setTimeout(function () {
            RE.bodyHeight('' + locY);
            //RE.callback('re-selection-height://','{"locY":"'+locY+'","bodyH":"'+height2+'"}');
        }, 200);
    }
}

RE.bottomClick = function (downX, downY) {
    //var height2 = document.body.offsetHeight;
    var height2 = RE.getBodyInnerHeight();
    RE.logger('判断', '' + M_Art.isAnima);
    if ((parseInt(downY) + 30) > height2 && !M_Art.isAnima) {
        //点击页面底部，自动聚焦到最后一个光标
        setTimeout(function () {
            var lastText = $("body").find(".M-Art-P,.M-Art-H1,.M-Art-H2,M-Art-H3,.M-Art-Ul").eq(-1);
            $("body").find(".M-Art-P,.M-Art-H1,.M-Art-H2,M-Art-H3,.M-Art-Ul").eq(-1).focus();
        }, 200);
    }
}

RE.callback = function (callbackScheme, callbackPath) {
    window.location.href = callbackScheme + callbackPath;
};

RE.logger = function (logTag, logContent) {
    window.do_question.logger(logTag, logContent);
}

RE.alert = function (logTag, logContent) {
    window.do_question.alert(logTag, logContent);
}

RE.setPlaceholder = function (placeholder) {
    //RE.editor.setAttribute("placeholder", placeholder);
    var firsttext = document.getElementsByClassName('M-Art-View-Con')[0].firstChild;
    firsttext.attr('-webkit-input-placeholder', placeholder);
    //firsttext.setAttribute("-webkit-input-placeholder", placeholder);
}

RE.getPreViewHtml = function () {
    //把图片框隐藏起来
    var yuanma = document.documentElement.outerHTML;
    window.do_question.onHtmlGet(yuanma);
}

/*检查是否编辑章节*/
RE.checkEdit= function () {
    var currentHtml = $(document.body).html();
    window.do_question.htmlChange(''+currentHtml!=historyHtml);
}

RE.saveHtml = function () {
    //把第一段文字的提示语藏起来
    try {
        $('.M-Art-P-Active').removeClass('M-Art-P-Active').removeAttr('data-placeholder');
        $('.M-ChapTitle-Temp,.M-SectionTitle-Temp').removeAttr('style');
        $('.M-Art-Template-Tools').remove();
    } catch (e) {
    }
    //把图片框隐藏起来
    M_Art.save();
    var imageList = '';
    var masks = document.getElementsByClassName('M-Chap-BgImg');
    for (var i = 0; i < masks.length; i++) {
        imageList = imageList + masks[i].getAttribute('src') + ";";
    }
    /*  var images = document.getElementsByClassName('M-Art-ImgBox');
    for (var i = 0; i < images.length; i++) {
        imageList = imageList + $(images[i]).find('img').attr('src') + ";";
    }*/
    $("body").find('img').each(function(){
        imageList = imageList + $(this).attr('src') + ";";
    });
    var chapName = '';
    var titles = document.getElementsByClassName('ArtH1');
    for (var i = 0; i < titles.length; i++) {
        chapName = titles[i].textContent;
    }
    if (chapName == '') {
        titles = document.getElementsByClassName('ArtH2');
        for (var i = 0; i < titles.length; i++) {
            chapName = titles[i].textContent;
            ;
        }
    }
    //标题正则替换
    chapName = helper.getTitle(chapName);
    var audioList = '';
    $('.M-Art-AudioBox').children().each(function () {
        audioList = audioList + $(this).attr('src') + ';';
    });
    var videoList = '';
    $('.M-Art-VideoBox').children().each(function () {
        videoList = videoList + $(this).attr('src') + ',' + $(this).attr('poster') + ';';
    });
    //删除font-face注入
    $('html').find('style').each(function () {
        var type = $(this).attr('name');
        if (type == 'androidFont') {
            $(this).remove();
        }
    });
    //$('body').removeAttr('style');

    $('body').css('padding-bottom', '').css('box-sizing', '');
    var yuanma = document.documentElement.outerHTML;
    window.do_question.saveHtml(yuanma, imageList, audioList, videoList, chapName);
}

RE.stopParentScroll = function () {
    //阻止父控件的滑动事件
    RE.callback('re-switch://', 'on');
}
RE.resumedParentScroll = function () {
    //恢复父控件的滑动事件
    RE.callback('re-switch://', 'off');
};

/*文字样式处理的方法*/
RE.setParagraphP = function () {
    //设置段落级别--正文
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        var paragrap = document.activeElement;
        if (paragrap.nodeName.toLowerCase() == 'p') {
            var className = paragrap.className.replace(new RegExp('M-Art-P', 'gm'), '').replace(new RegExp('M-Art-H1', 'gm'), '').replace(new RegExp('M-Art-H2', 'gm'), '').replace(new RegExp('M-Art-H3', 'gm'), '');
            paragrap.className = ('M-Art-P' + ' ' + className).replace(new RegExp('  ', 'gm'), ' ');
        } else if (paragrap.nodeName.toLowerCase() == 'ul') {
            $(paragrap).find('li').each(function () {
                var tempId = "" + new Date().getTime();
                $(this).replaceWith('<p class="M-Art-P" id="' + tempId + '">' + $(this).html() + '</p>');
                var newP = document.getElementById(tempId);
                $(newP).attr('id', '');
                $(newP).attr('contentEditable', 'true');
                //RE.upadteEventListener(newP,"keydown",function(){RE.textkeydown(event);});
            });
            $(paragrap).replaceWith($(paragrap).html());
            $('.M-Art-P').each(function () {
                $(this).attr('contentEditable', 'true');
                //RE.upadteEventListener(this,"keydown",function(){RE.textkeydown(event);});
                //RE.upadteEventListener(this,"paste",function(){RE.pasteContent(event);});
            });
        } else {
            $(paragrap).replaceWith('<p class="M-Art-P">' + $(paragrap).html() + '</p>');
            $(paragrap).attr('contentEditable', 'true');
            //RE.upadteEventListener(paragrap,"keydown",function(){RE.textkeydown(event);});
        }
    }
}
RE.setParagraphTitle= function (titleClass) {
    //设置段落级别-标题
        var selection = window.getSelection();
        if (selection.rangeCount > 0) {
            var range = selection.getRangeAt(0);
            if (RE.isTextTag(document.activeElement) == false) {
                return;
            }
            var paragrap = document.activeElement;
            if (paragrap.nodeName.toLowerCase() == 'p') {
                var className = paragrap.className.replace(new RegExp('M-Art-P', 'gm'), '').replace(new RegExp('M-Art-H1', 'gm'), '').replace(new RegExp('M-Art-H2', 'gm'), '').replace(new RegExp('M-Art-H3', 'gm'), '');
                paragrap.className = (titleClass + ' ' + className).replace(new RegExp('  ', 'gm'), ' ');
            } else if (paragrap.nodeName.toLowerCase() == 'ul') {
                $(paragrap).find('li').each(function () {
                    var tempId = "" + new Date().getTime();
                    $(this).replaceWith('<p class="'+titleClass+'" id="' + tempId + '">' + $(this).html() + '</p>');
                    var newP = document.getElementById(tempId);
                    $(newP).attr('id', '');
                });
                $(paragrap).replaceWith($(paragrap).html());
                $('.'+titleClass).each(function () {
                    $(this).attr('contentEditable', 'true');
                });
            } else {
                $(paragrap).replaceWith('<p class="'+titleClass+'">' + $(paragrap).html() + '</p>');
                $(paragrap).attr('contentEditable', 'true');
            }
        }
}
RE.setParagraphBigTitle = function () {
    //设置段落级别--大标题
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        var paragrap = document.activeElement;
        if (paragrap.nodeName.toLowerCase() == 'p') {
            var className = paragrap.className.replace(new RegExp('M-Art-P', 'gm'), '').replace(new RegExp('M-Art-H1', 'gm'), '').replace(new RegExp('M-Art-H2', 'gm'), '').replace(new RegExp('M-Art-H3', 'gm'), '');
            paragrap.className = ('M-Art-H1' + ' ' + className).replace(new RegExp('  ', 'gm'), ' ');
        } else if (paragrap.nodeName.toLowerCase() == 'ul') {
            $(paragrap).find('li').each(function () {
                var tempId = "" + new Date().getTime();
                $(this).replaceWith('<p class="M-Art-H1" id="' + tempId + '">' + $(this).html()+ '</p>');
                var newP = document.getElementById(tempId);
                $(newP).attr('id', '');
            });
            $(paragrap).replaceWith($(paragrap).html());
            $('.M-Art-H1').each(function () {
                $(this).attr('contentEditable', 'true');
                //RE.upadteEventListener(this,"keydown",function(){RE.textkeydown(event);});
                //RE.upadteEventListener(this,"paste",function(){RE.pasteContent(event);});
            });
        } else {
            $(paragrap).replaceWith('<p class="M-Art-H1">' + $(paragrap).html() + '</p>');
            $(paragrap).attr('contentEditable', 'true');
            //RE.upadteEventListener(paragrap,"keydown",function(){RE.textkeydown(event);});
        }
    }
}
RE.setParagraphSmallTitle = function () {
    //设置段落级别--小标题
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        var paragrap = document.activeElement;
        if (paragrap.nodeName.toLowerCase() == 'p') {
            var className = paragrap.className.replace(new RegExp('M-Art-P', 'gm'), '').replace(new RegExp('M-Art-H1', 'gm'), '').replace(new RegExp('M-Art-H2', 'gm'), '').replace(new RegExp('M-Art-H3', 'gm'), '');
            paragrap.className = ('M-Art-H2' + ' ' + className).replace(new RegExp('  ', 'gm'), ' ');
        } else if (paragrap.nodeName.toLowerCase() == 'ul') {
            $(paragrap).find('li').each(function () {
                var tempId = "" + new Date().getTime();
                $(this).replaceWith('<p class="M-Art-H2" id="' + tempId + '">' + $(this).html() + '</p>');
                var newP = document.getElementById(tempId);
                $(newP).attr('id', '');
            });
            $(paragrap).replaceWith($(paragrap).html());
            $('.M-Art-H2').each(function () {
                $(this).attr('contentEditable', 'true');
                //RE.upadteEventListener(this,"keydown",function(){RE.textkeydown(event);});
                //RE.upadteEventListener(this,"paste",function(){RE.pasteContent(event);});
            });
        } else {
            $(paragrap).replaceWith('<p class="M-Art-H2">' + $(paragrap).html() + '</p>');
            $(paragrap).attr('contentEditable', 'true');
            //RE.upadteEventListener(paragrap,"keydown",function(){RE.textkeydown(event);});
        }
    }
}
RE.setParagraphUnOrder = function () {
    //设置段落级别--无序列表
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        var paragrap = document.activeElement;
        if (paragrap.nodeName.toLowerCase() == 'ul') {
        } else {
            var tempId = "" + new Date().getTime();
            $(paragrap).replaceWith('<ul class="M-Art-Ul" id="' + tempId + '"><li>' + $(paragrap).html() + '</li></ul>');
            var newParagrap = document.getElementById(tempId);
            $(newParagrap).attr('id', '');
            $(newParagrap).attr('contentEditable', 'true');
            //RE.upadteEventListener(newParagrap,"keydown",function(){RE.textkeydown(event);});
            newParagrap.focus();
        }
    }
}
RE.setParagraphAlign = function (alignType) {
    //设置段落样式--对齐
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        var paragrap = document.activeElement;
        var className = paragrap.className.replace(new RegExp('M-Art-AlignLeft', 'gm'), '').replace(new RegExp('M-Art-AlignCenter', 'gm'), '').replace(new RegExp('M-Art-AlignRight', 'gm'), '');
        paragrap.className = (className + ' ' + alignType).replace(new RegExp('  ', 'gm'), ' ');
    }
}
RE.setFontFamily = function (fontFamily) {
    //设置文字样式--字体
    var selection = window.getSelection();
    if (selection.rangeCount > 0 && selection && selection.toString().length > 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        var classname = '  ';
        var newSpan = document.createElement('span');
        newSpan.className = '';
        newSpan.appendChild(range.extractContents());
        range.insertNode(newSpan);
        newSpan = RE.meshSpan(newSpan, classname);
        //遍历所有下级span标签，重设font-family
        $(newSpan).css('font-family', fontFamily);
        $(newSpan).find('span').each(function () {
            $(this).css('font-family', fontFamily);
        });
        range.selectNode(newSpan);
        selection.removeAllRanges();
        selection.addRange(range);
    } else if (selection.rangeCount > 0 && selection && selection.toString().length <= 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        var node = range.commonAncestorContainer;
        range.collapse(false);
        var hasR = range.createContextualFragment('<span style="font-family:' + fontFamily + '">&nbsp;</span>');
        range.insertNode(hasR);
        range.startContainer = hasR;
        range.endContainer = hasR;
        range.commonAncestorContainer = hasR;
        range.startOffset = 0;
        range.endOffset = 0;
        selection.removeAllRanges();
        selection.addRange(range);
    }
}
RE.setFontSize = function (fontSize) {
    //设置文字样式--字号
    var selection = window.getSelection();
    if (selection.rangeCount > 0 && selection && selection.toString().length > 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        var classname = '  ';
        var newSpan = document.createElement('span');
        newSpan.className = '';
        newSpan.appendChild(range.extractContents());
        range.insertNode(newSpan);
        newSpan = RE.meshSpan(newSpan, classname);
        //遍历所有下级span标签，重设font-size
        $(newSpan).css('font-size', fontSize);
        $(newSpan).find('span').each(function () {
            $(this).css('font-size', fontSize);
        });
        range.selectNode(newSpan);
        selection.removeAllRanges();
        selection.addRange(range);
    } else if (selection.rangeCount > 0 && selection && selection.toString().length <= 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        var node = range.commonAncestorContainer;
        range.collapse(false);
        var hasR = range.createContextualFragment('<span style="font-size:' + fontSize + '">&nbsp;</span>');
        range.insertNode(hasR);
        range.startContainer = hasR;
        range.endContainer = hasR;
        range.commonAncestorContainer = hasR;
        range.startOffset = 0;
        range.endOffset = 0;
        selection.removeAllRanges();
        selection.addRange(range);
    }
}
RE.setFontBold = function (isBold) {
    //设置文字样式--加粗
    var selection = window.getSelection();
    if (selection.rangeCount > 0 && selection && selection.toString().length > 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        var classname = 'M-Art-Font-Strong';
        var newSpan = document.createElement('span');
        newSpan.className = '';
        newSpan.appendChild(range.extractContents());
        range.insertNode(newSpan);
        //range.surroundContents(newSpan);
        newSpan = RE.meshSpan(newSpan, classname);
        if (isBold == '1') {
            newSpan.className = (newSpan.className + ' ' + classname).replace(new RegExp('  ', 'gm'), ' ');
        } else {
            //遍历所有上下级span标签，去除classname
            while (newSpan.parentNode.nodeName.toLowerCase() == 'span') {
                RE.ClearSpan(newSpan.parentNode);
                var index = RE.getSpanIndex(newSpan);
                var parent = newSpan.parentNode;
                $(parent).attr('useless', 'forfind');
                var index2 = RE.getSpanIndex(parent);
                var parentP = parent.parentNode;
                var htmlInner = $(parentP).html().replace(parent.outerHTML, RE.combineSpan(parent));
                $(parentP).html(htmlInner);
                newSpan = parentP.childNodes[(index + index2)];
            }
            newSpan.className = newSpan.className.replace(new RegExp(classname, 'gm'), '').replace(new RegExp('  ', 'gm'), ' ');
            $(newSpan).find('span').each(function () {
                var classStr = $(this).attr('class');
                if (typeof(classStr) != "undefined" && classStr.indexOf(classname) >= 0) {
                    $(this).attr('class', classStr.replace(new RegExp(classname, 'gm'), '').replace(new RegExp('  ', 'gm'), ' '));
                }
            });

        }
        range.selectNode(newSpan);
        selection.removeAllRanges();
        selection.addRange(range);
    } else if (selection.rangeCount > 0 && selection && selection.toString().length <= 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        var classname = '';
        if (isBold == '1') {
            classname = 'M-Art-Font-Strong';
        }else{
            classname = 'M-Art-Font-UnStrong';
        }
        range.collapse(false);
        var hasR = range.createContextualFragment('<span id="selectionSpan" class="' + classname + '">&#65279;</span>');
        range.insertNode(hasR);
        if(classname=='M-Art-Font-UnStrong'){
            //外部有嵌套样式，需要清理
            var newSpan = $(document.activeElement).find('.M-Art-Font-UnStrong');
            while (newSpan.parents('.M-Art-Font-Strong').length>0) {
                newSpan.parents('.M-Art-Font-Strong').each(function (){
                    RE.ClearSpan(this);
                    $(this).removeClass('M-Art-Font-Strong');
                    $(this).children('span').addClass('M-Art-Font-Strong');
                });
                newSpan.removeClass('M-Art-Font-Strong');
            }
            newSpan.removeClass('M-Art-Font-UnStrong');
        }
        /*range.startContainer = hasR;
        range.endContainer = hasR;
        range.commonAncestorContainer = hasR;
        range.startOffset = 0;
        range.endOffset = 0;
        selection.removeAllRanges();
        selection.addRange(range);*/

        var sel = window.getSelection();
        var ran = document.createRange();
        var node = document.getElementById('selectionSpan');
        ran.setStart(node, 1);
        ran.setEnd(node, 1);
        sel.removeAllRanges();
        sel.addRange(ran);
        $(node).removeAttr('id');
        /*ran.collapse(true);*/
    }
}
RE.setFontItalic = function (isItalic) {
    //设置文字样式--斜体
    var selection = window.getSelection();
    if (selection.rangeCount > 0 && selection && selection.toString().length > 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        var classname = 'M-Art-Font-Italic';
        var newSpan = document.createElement('span');
        newSpan.className = '';
        newSpan.appendChild(range.extractContents());
        range.insertNode(newSpan);
        //range.surroundContents(newSpan);
        newSpan = RE.meshSpan(newSpan, classname);
        if (isItalic == '1') {
            newSpan.className = (newSpan.className + ' ' + classname).replace(new RegExp('  ', 'gm'), ' ');
        } else {
            //遍历所有上下级span标签，去除classname
            while (newSpan.parentNode.nodeName.toLowerCase() == 'span') {
                RE.ClearSpan(newSpan.parentNode);
                var index = RE.getSpanIndex(newSpan);
                var parent = newSpan.parentNode;
                $(parent).attr('useless', 'forfind');
                var index2 = RE.getSpanIndex(parent);
                var parentP = parent.parentNode;
                var htmlInner = $(parentP).html().replace(parent.outerHTML, RE.combineSpan(parent));
                $(parentP).html(htmlInner);
                newSpan = parentP.childNodes[(index + index2)];
            }
            newSpan.className = newSpan.className.replace(new RegExp(classname, 'gm'), '').replace(new RegExp('  ', 'gm'), ' ');
            $(newSpan).find('span').each(function () {
                var classStr = $(this).attr('class');
                if (typeof(classStr) != "undefined" && classStr.indexOf(classname) >= 0) {
                    $(this).attr('class', classStr.replace(new RegExp(classname, 'gm'), '').replace(new RegExp('  ', 'gm'), ' '));
                }
            });
        }
        range.selectNode(newSpan);
        selection.removeAllRanges();
        selection.addRange(range);
    } else if (selection.rangeCount > 0 && selection && selection.toString().length <= 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        var classname = '';
        if (isItalic == '1') {
            classname = 'M-Art-Font-Italic';
        }else {
            classname = 'M-Art-Font-UnItalic';
        }
        range.collapse(false);
        var hasR = range.createContextualFragment('<span class="' + classname + '">&nbsp;</span>');
        range.insertNode(hasR);
        if(classname=='M-Art-Font-UnItalic'){
            //外部有嵌套样式，需要清理
            var newSpan = $(document.activeElement).find('.M-Art-Font-UnItalic');
            while (newSpan.parents('.M-Art-Font-Italic').length>0) {
                newSpan.parents('.M-Art-Font-Italic').each(function (){
                    RE.ClearSpan(this);
                    $(this).removeClass('M-Art-Font-Italic');
                    $(this).children('span').addClass('M-Art-Font-Italic');
                });
                newSpan.removeClass('M-Art-Font-Italic');
            }
            newSpan.removeClass('M-Art-Font-UnItalic');
        }
        range.startContainer = hasR;
        range.endContainer = hasR;
        range.commonAncestorContainer = hasR;
        range.startOffset = 0;
        range.endOffset = 0;
        selection.removeAllRanges();
        selection.addRange(range);
    }
}
RE.setFontDecoration= function (isDecoration) {
    //设置文字样式--删除线
    var selection = window.getSelection();
    if (selection.rangeCount > 0 && selection && selection.toString().length > 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        var classname = 'M-Art-Font-LineThrough';
        var newSpan = document.createElement('span');
        newSpan.className = '';
        newSpan.appendChild(range.extractContents());
        range.insertNode(newSpan);
        //range.surroundContents(newSpan);
        newSpan = RE.meshSpan(newSpan, classname);
        if (isDecoration == '1') {
            newSpan.className = (newSpan.className + ' ' + classname).replace(new RegExp('  ', 'gm'), ' ');
        } else {
            //遍历所有上下级span标签，去除classname
            while (newSpan.parentNode.nodeName.toLowerCase() == 'span') {
                RE.ClearSpan(newSpan.parentNode);
                var index = RE.getSpanIndex(newSpan);
                var parent = newSpan.parentNode;
                $(parent).attr('useless', 'forfind');
                var index2 = RE.getSpanIndex(parent);
                var parentP = parent.parentNode;
                var htmlInner = $(parentP).html().replace(parent.outerHTML, RE.combineSpan(parent));
                $(parentP).html(htmlInner);
                newSpan = parentP.childNodes[(index + index2)];
            }
            newSpan.className = newSpan.className.replace(new RegExp(classname, 'gm'), '').replace(new RegExp('  ', 'gm'), ' ');
            $(newSpan).find('span').each(function () {
                var classStr = $(this).attr('class');
                if (typeof(classStr) != "undefined" && classStr.indexOf(classname) >= 0) {
                    $(this).attr('class', classStr.replace(new RegExp(classname, 'gm'), '').replace(new RegExp('  ', 'gm'), ' '));
                }
            });
        }
        range.selectNode(newSpan);
        selection.removeAllRanges();
        selection.addRange(range);
    } else if (selection.rangeCount > 0 && selection && selection.toString().length <= 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        var classname = '';
        if (isDecoration == '1') {
            classname = 'M-Art-Font-LineThrough';
        }else {
            classname = 'M-Art-Font-UnLineThrough';
        }
        range.collapse(false);
        var hasR = range.createContextualFragment('<span class="' + classname + '">&nbsp;</span>');
        range.insertNode(hasR);
        if(classname=='M-Art-Font-UnLineThrough'){
            //外部有嵌套样式，需要清理
            var newSpan = $(document.activeElement).find('.M-Art-Font-UnLineThrough');
            while (newSpan.parents('.M-Art-Font-LineThrough').length>0) {
                newSpan.parents('.M-Art-Font-LineThrough').each(function (){
                    RE.ClearSpan(this);
                    $(this).removeClass('M-Art-Font-LineThrough');
                    $(this).children('span').addClass('M-Art-Font-LineThrough');
                });
                newSpan.removeClass('M-Art-Font-LineThrough');
            }
            newSpan.removeClass('M-Art-Font-UnLineThrough');
        }
        range.startContainer = hasR;
        range.endContainer = hasR;
        range.commonAncestorContainer = hasR;
        range.startOffset = 0;
        range.endOffset = 0;
        selection.removeAllRanges();
        selection.addRange(range);
    }
}
RE.setFontUnderLine = function (isUnderLine) {
    //设置文字样式--下滑线
    var selection = window.getSelection();
    if (selection.rangeCount > 0 && selection && selection.toString().length > 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        var classname = 'M-Art-Font-UnderLine';
        var newSpan = document.createElement('span');
        newSpan.className = '';
        newSpan.appendChild(range.extractContents());
        range.insertNode(newSpan);
        //range.surroundContents(newSpan);
        newSpan = RE.meshSpan(newSpan, classname);
        if (isUnderLine == '1') {
            newSpan.className = (newSpan.className + ' ' + classname).replace(new RegExp('  ', 'gm'), ' ');
        } else {
            //遍历所有上下级span标签，去除classname
            while (newSpan.parentNode.nodeName.toLowerCase() == 'span') {
                RE.ClearSpan(newSpan.parentNode);
                var index = RE.getSpanIndex(newSpan);
                var parent = newSpan.parentNode;
                $(parent).attr('useless', 'forfind');
                var index2 = RE.getSpanIndex(parent);
                var parentP = parent.parentNode;
                var htmlInner = $(parentP).html().replace(parent.outerHTML, RE.combineSpan(parent));
                $(parentP).html(htmlInner);
                newSpan = parentP.childNodes[(index + index2)];
            }
            newSpan.className = newSpan.className.replace(new RegExp(classname, 'gm'), '').replace(new RegExp('  ', 'gm'), ' ');
            $(newSpan).find('span').each(function () {
                var classStr = $(this).attr('class');
                if (typeof(classStr) != "undefined" && classStr.indexOf(classname) >= 0) {
                    $(this).attr('class', classStr.replace(new RegExp(classname, 'gm'), '').replace(new RegExp('  ', 'gm'), ' '));
                }
            });
        }
        range.selectNode(newSpan);
        selection.removeAllRanges();
        selection.addRange(range);
    } else if (selection.rangeCount > 0 && selection && selection.toString().length <= 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        var classname = '';
        if (isUnderLine == '1') {
            classname = 'M-Art-Font-UnderLine';
        } else {
            classname = 'M-Art-Font-UnUnderLine';
        }
        range.collapse(false);
        var hasR = range.createContextualFragment('<span class="' + classname + '">&nbsp;</span>');
        range.insertNode(hasR);
        if(classname=='M-Art-Font-UnUnderLine'){
            //外部有嵌套样式，需要清理
            var newSpan = $(document.activeElement).find('.M-Art-Font-UnUnderLine');
            while (newSpan.parents('.M-Art-Font-UnderLine').length>0) {
                newSpan.parents('.M-Art-Font-UnderLine').each(function (){
                    RE.ClearSpan(this);
                    $(this).removeClass('M-Art-Font-UnderLine');
                    $(this).children('span').addClass('M-Art-Font-UnderLine');
                });
                newSpan.removeClass('M-Art-Font-UnderLine');
            }
            newSpan.removeClass('M-Art-Font-UnUnderLine');
        }
        range.startContainer = hasR;
        range.endContainer = hasR;
        range.commonAncestorContainer = hasR;
        range.startOffset = 0;
        range.endOffset = 0;
        selection.removeAllRanges();
        selection.addRange(range);
    }
}
RE.setFontColor = function (fontColor) {
    //设置文字样式--颜色
    var selection = window.getSelection();
    if (selection.rangeCount > 0 && selection && selection.toString().length > 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        var classname = '  ';
        var newSpan = document.createElement('span');
        newSpan.className = '';
        newSpan.appendChild(range.extractContents());
        range.insertNode(newSpan);
        newSpan = RE.meshSpan(newSpan, classname);
        //遍历所有下级span标签，重设color的class
        RE.clearColor(newSpan);
        newSpan.className = newSpan.className + ' ' + fontColor;
        $(newSpan).find('span').each(function () {
            RE.clearColor(this);
            this.className = this.className + ' ' + fontColor;
        });
        range.selectNode(newSpan);
        selection.removeAllRanges();
        selection.addRange(range);
    } else if (selection.rangeCount > 0 && selection && selection.toString().length <= 0) {
        var range = selection.getRangeAt(0);
        if (RE.isTextTag(document.activeElement) == false) {
            return;
        }
        var node = range.commonAncestorContainer;
        range.collapse(false);
        var hasR = range.createContextualFragment('<span class="' + fontColor + '">&nbsp;</span>');
        range.insertNode(hasR);
        range.startContainer = hasR;
        range.endContainer = hasR;
        range.commonAncestorContainer = hasR;
        range.startOffset = 0;
        range.endOffset = 0;
        selection.removeAllRanges();
        selection.addRange(range);
    }
}
//清空span的color样式
RE.clearColor = function (span) {
    var classStr = span.className;
    if (typeof(classStr) != "undefined") {
        span.className = classStr.replace(new RegExp('M-Art-Color-1', 'gm'), '').replace(new RegExp('M-Art-Color-2', 'gm'), '').replace(new RegExp('M-Art-Color-3', 'gm'), '').replace(new RegExp('M-Art-Color-4', 'gm'), '').replace(new RegExp('M-Art-Color-5', 'gm'), '').replace(new RegExp('M-Art-Color-6', 'gm'), '').replace(new RegExp('M-Art-Color-7', 'gm'), '').replace(new RegExp('  ', 'gm'), ' ');
    } else {
        span.className = '';
    }
}
//清理span标签，删除空文本，补全文本标签
RE.ClearSpan = function (parent) {
    for (var i = 0; i < parent.childNodes.length; i++) {
        if (parent.childNodes[i].nodeName.toLowerCase() == '#text') {
            if (parent.childNodes[i].textContent.length > 0) {
                $(parent.childNodes[i]).wrap('<span></span>');
            } else {
                $(parent.childNodes[i]).remove();
            }
        }
    }
}
//获取span在父元素的位置，并将文本补全span标签
RE.getSpanIndex = function (span) {
    var parent = span.parentNode;
    var index = -1;
    for (var i = 0; i < parent.childNodes.length; i++) {
        if (span == parent.childNodes[i]) {
            index = i;
        }
    }
    return index;
}
//将span的style属性下发到所有子标签
RE.combineSpan = function (span) {
    for (var i = 0; i < span.childNodes.length; i++) {
        if(span.childNodes[i].nodeName.toLowerCase()=='span'){
            span.childNodes[i].outerHTML = RE.copyStyletoChild(span.childNodes[i]);
        }
    }
    return $(span).html();
}
//拷贝子标签的style属性
RE.copyStyletoChild = function (child) {
    var oldClass = '';
    var bold = $(child).css('font-weight');
    if (bold == 'bold') {
        oldClass += 'M-Art-Font-Strong ';
    }
    var italic = $(child).css('font-style');
    if (italic == 'italic') {
        oldClass += 'M-Art-Font-Italic ';
    }
    var underline = $(child).css('text-decoration');
    if (underline == 'underline') {
        oldClass += 'M-Art-Font-UnderLine ';
    }
    if (underline == 'line-through') {
        oldClass += 'M-Art-Font-LineThrough ';
    }
    var color = $(child).css('color');
    if (color == '') {

    }
    /*$(child).css('font-size', $(child).css('font-size'));*/
    $(child).css('font-family', $(child).css('font-family'));
    oldClass = oldClass.replace(new RegExp('  ', 'gm'), ' ');
    child.className = oldClass;
    return child.outerHTML;
}
//将子标签的属性拷贝到父标签
RE.copyStyle = function (parent, child, noClass) {
    var oldClass = '';
    var bold = $(child).css('font-weight');
    if (bold == 'bold') {
        oldClass += 'M-Art-Font-Strong ';
    }
    var italic = $(child).css('font-style');
    if (italic == 'italic') {
        oldClass += 'M-Art-Font-Italic ';
    }
    var underline = $(child).css('text-decoration');
    if (underline == 'underline') {
        oldClass += 'M-Art-Font-UnderLine ';
    }
    if (underline == 'line-through') {
        oldClass += 'M-Art-Font-LineThrough ';
    }
    var color = $(child).css('color');
    if (color == 'rgb(136,136,136)') {
        oldClass += 'M-Art-Color-2 ';
    } else if (color == 'rgb(244,53,48)') {
        oldClass += 'M-Art-Color-3 ';
    } else if (color == 'rgb(255,157,0)') {
        oldClass += 'M-Art-Color-4 ';
    } else if (color == 'rgb(9,186,7)') {
        oldClass += 'M-Art-Color-5 ';
    } else if (color == 'rgb(0,160,233)') {
        oldClass += 'M-Art-Color-6 ';
    } else if (color == 'rgb(171,71,238)') {
        oldClass += 'M-Art-Color-7 ';
    } else {
        oldClass += 'M-Art-Color-1 ';
    }
    /*$(parent).css('font-size', $(child).css('font-size'));*/
    $(parent).css('font-family', $(child).css('font-family'));
    oldClass = oldClass.replace(new RegExp(noClass, 'gm'), '').replace(new RegExp('  ', 'gm'), ' ');
    parent.className = oldClass;
    return parent;
}

RE.meshSpan = function (newSpan, classname) {
    //合并冗余标签
    while (newSpan.childNodes.length == 1 && newSpan.childNodes[0].nodeName.toLowerCase() == 'span') {
        var child = newSpan.childNodes[0];
        newSpan = RE.copyStyle(newSpan, child, classname);
        $(newSpan).html($(child).html());
    }
    while (newSpan.parentNode.nodeName.toLowerCase() == 'span' && $(newSpan.parentNode).html() == newSpan.outerHTML) {
        var parent = newSpan.parentNode;
        parent = RE.copyStyle(parent, newSpan, classname);
        $(parent).html($(newSpan).html());
        newSpan = parent;
    }
    return newSpan;
}
//替换章标题的模板
RE.changeChapMode = function (html) {
    mu.disconnect();
    var chapName = '';
    var titles;
    $('.ArtH1').each(function () {
        titles = $(this);
        chapName = $(this)[0].textContent;
    });
    $('.M-ChapTitle-Temp').each(function () {
        titles = $(this);
        titles.find('.M-Art-Template-Tools').remove();
        chapName = titles.text();
    });
    if (titles.length > 0) {
        titles.replaceWith(html);
        //添加标题按钮
        if($('.M-ChapTitle-Temp,.M-SectionTitle-Temp').find('.Btn-Select-Template').length==0){
            $('.M-ChapTitle-Temp,.M-SectionTitle-Temp').append('<div class="M-Art-Template-Tools"><div class="Btn-Select-Template">标题背景</div></div>')
        }
        $('.ArtH1').each(function () {
            $(this).html(chapName);
            $(this).attr('contentEditable', 'true');
            $(this)[0].onkeydown = function (event) {
                var wasEnterPressed = (event.keyCode == '13');
                if (wasEnterPressed) {
                    event.cancelBubble = true;
                    event.preventDefault();
                    event.stopPropagation();
                }
            };
        });
    }
    mu.reObserve();
}

//替换节标题的模板
RE.changeTitleMode = function (html) {
    mu.disconnect();
    var chapName = '';
    var titles;
    $('.ArtH2').each(function () {
        titles = $(this);
        chapName = $(this)[0].textContent;
    });
    $('.M-SectionTitle-Temp').each(function () {
        titles = $(this);
        titles.find('.M-Art-Template-Tools').remove();
        chapName = titles.text();
    });
    if (titles.length > 0) {
        titles.replaceWith(html);
        //添加标题按钮
        if($('.M-ChapTitle-Temp,.M-SectionTitle-Temp').find('.Btn-Select-Template').length==0){
            $('.M-ChapTitle-Temp,.M-SectionTitle-Temp').append('<div class="M-Art-Template-Tools"><div class="Btn-Select-Template">标题背景</div></div>')
        }
        $('.ArtH2').each(function () {
            $(this).html(chapName);
            $(this).attr('contentEditable', 'true');
            $(this)[0].onkeydown = function (event) {
                var wasEnterPressed = (event.keyCode == '13');
                if (wasEnterPressed) {
                    event.cancelBubble = true;
                    event.preventDefault();
                    event.stopPropagation();
                }
            };
        });
    }
    mu.reObserve();
}
window.RE = RE;
